require 'rubygems'
require 'rest_client'
require 'json'
require 'fileutils'
require 'colorize'

if ARGV.count != 2
    puts "Usage: <-gd gitrootdir> "
    exit 1
end

count=0
ARGV.each do |option|
    case option
    when "-h"
        puts "Usage: <-gd gitrootdir>"
        puts "where (gitrootdir) is the base directory containing the git repositories"
        exit 1
    when "-gd"
        @my_git_rootdir=ARGV[count+1]
    end
    count=count+1
end

def print_and_flush(str)
    print str
      $stdout.flush
end

Dir.foreach(@my_git_rootdir) do |entry| #PROJECT level dir
  next if entry == '.' or entry == '..'
  gitdir="#{ @my_git_rootdir + '/' + entry}" #git repo level dirs
  next if File.file?(gitdir)
  other_branches=Array.new
  other_branches=%x[ cd #{gitdir}  && git branch | grep -v "*" 2>/dev/null ].gsub(' ','').split("\n")
  active_branches=%x[ cd #{gitdir} && git rev-parse --symbolic-full-name --abbrev-ref HEAD 2>/dev/null ].gsub(' ','').chomp
  print_and_flush "[#{active_branches.red}]"
  other_branches.each do |b|
    print_and_flush ",(#{b.gsub(' ','').gsub('\n','').chomp.green })"
  end
  print_and_flush " => #{gitdir.gsub(@my_git_rootdir.to_s,'')}\n"
end

